#include "btree.h"

/*
 * Searches the leaf at the node stored at the given page for the given key.
 * Returns the offset from the postings file, or NON_EXISTENT, if not found.
 */
long search_leaf(PageHdr* page_ptr, char* key) {
    /* Find insertion position */
    KeyRecord* key_list_iterator = page_ptr->key_list_ptr;
    int count = 0, found;
    int insert_pos = find_insertion_pos(key_list_iterator, key, &found, page_ptr->num_keys, count);

    /* key is already in the B-Tree */
    if (found == TRUE) {
        for (int i = 0; i < insert_pos - 1; i++)
            key_list_iterator = key_list_iterator->next;
        return key_list_iterator->posting;
    } else {
        return NON_EXISTENT;
    }
}
