#include "btree.h"

/*
 * Calculate the number of bytes and number of keys for a given page_ptr page image
 * and fill in the appropriate fields in the structure.
 */
void update_page_header(PageHdr* page_ptr) {  /* Pointer to page being filled-in */

    int bytes = sizeof(page_ptr->page_type) + sizeof(page_ptr->page_num)
                + sizeof(page_ptr->next_leaf_page_num) + sizeof(page_ptr->num_bytes)
                + sizeof(page_ptr->num_keys);
    int keys = 0;
    for (KeyRecord* p = page_ptr->key_list_ptr; p != NULL; p = p->next) {
        keys++;
        bytes += p->key_len + sizeof(long) + sizeof(int);
    }
    page_ptr->num_bytes = bytes;
    page_ptr->num_keys  = keys;
}

