#ifndef HELPERS_H
#define HELPERS_H

#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#include <string.h>

/*
 * Useful helper functions.
 */

static inline int order(char c) {
    const int AB_SIZE = 27;  /* alphabet size + 1 for the blank */
    if (c == ' ') return 0;
    if (isdigit(c)) return c - '0' + 1;
    if (!isalpha(c)) return AB_SIZE;
    if (islower(c)) return c - 'a' + 1;
    return c - 'A' + 1;
}

static inline int check_malloc(void* ptr, char* var_name) {
    if (ptr == NULL) {
        printf("cannot alloc. %s\n", var_name);
        return ERROR;
    }
    return TRUE;
}

static inline int check_file(FILE* fp, char* fname) {
    if (fp == NULL) {
        printf("cannot open %s\n", fname);
        return ERROR;
    }
    return TRUE;
}

static inline void goto_eof(FILE* fp) { fseek(fp, 0, 2); }

/* returns the size of a file, in bytes; seeks to eof */
static inline long fsize(FILE* fp) {
    goto_eof(fp);
    return ftell(fp);
}

/* returns the size of a file, in bytes */
static inline long ffsize(FILE* fp) {
    long pos = ftell(fp);  /* current position, to return to */
    long size = fsize(fp);
    fseek(fp, pos, 0);
    return size;
}

static inline int check_io(int status, char* msg) {
    if (status <= 0) {
        printf("i/o error in %s\n", msg);
        return ERROR;
    }
    return TRUE;
}

/* Convert string to lowercase */
static inline void str_to_lower(char* s)
{ for (; *s; ++s) *s = tolower(*s); }

/* Check if string contains only alphanumerics. */
static inline int is_word_legal(char* s) {
    for (; *s; ++s)
        if (!isalpha(*s)) {
            printf("illegal word:|%s|\n", s);
            return FALSE;
        }
    return TRUE;
}

/* we don't need ASSERT and botch() - there is assert.h */
/*
#ifdef DEBUG
#define ASSERT(p) if(!(p)) botch("p"); else
#else
#define ASSERT(p)
#endif
*/

#endif