#include "postings.h"

/*
 * Add a posting at the given posting_offset pointing to the given doc_offset.
 */
void create_posting(long doc_offset, long* posting_offset) {
    /* get a posting block of minimum size */
    *posting_offset = get_record(1);

    /* Write the new posting to disk */
    fseek(fp_postings, *posting_offset, 0);
    long num_ptrs = 1;
    fwrite(&num_ptrs, sizeof(num_ptrs), 1, fp_postings);
    fwrite(&doc_offset, sizeof(doc_offset), 1, fp_postings);

    /* fill in any extra space with filler */
    /* this should not be executed if first listsize is 1 */
    long space_filler = 0;
    for (long i = num_ptrs; i < MAX_DOCS_PTRS; i++)
        fwrite(&space_filler, sizeof(space_filler), 1, fp_postings);
}
