#include "postings.h"

/*
 * this function returns a file position pointer a free block equal to
 * or greater than the passed size (size). If there is a block of appropriate
 * size in the freelist, it is removed and a pointer to it returned. If not,
 * a dummy block is set up at the end of the file and a pointer to it is returned.
 *
 * The file pointer cannot be assumed to be in the original position after
 * executing this function
 */

long get_record(long size) {
    int  i = 0, n = 0;
    long dummy, head, nextptr, save;
    rewind(fp_postings);

    /* find index of proper size freelist */
    while (LIST_SIZE[i] < size)
        i++;
    /* appropriate size list is now of size LIST_SIZE[i] */

    /* read through all freelist heads of smaller size blocks which
    precede the one of appropriate size */
    for (n = 0; n < i; n++)
        fread(&dummy, sizeof(dummy), 1, fp_postings);

    /* record position of file pointer in case update of head is needed */
    save = ftell(fp_postings);
    /* read in head of freelist of appropriate size */
    fread(&head, sizeof(head), 1, fp_postings);

    /* check to see if freelist exists */
    /* if not return pointer to end of file */
    if (head == -1) {
        /* set up a dummy record at the end of the file and return a pointer
        to it */
        long dummynum = 0;
        long dummyptr = 0;

        goto_eof(fp_postings);
        save = ftell(fp_postings);
        /* write out empty record to allocate space at end of file */
        fwrite(&dummynum, sizeof(dummynum), 1, fp_postings);
        for (n = 0; n < LIST_SIZE[i]; n++)
            fwrite(&dummyptr, sizeof(dummyptr), 1, fp_postings);
        return save;
    }

    /* read in pointer to next block in list */
    fseek(fp_postings, head, 0);
    fread(&nextptr, sizeof(nextptr), 1, fp_postings);

    /* write the next block in freelist as new head pointer */
    fseek(fp_postings, save, 0);
    fwrite(&nextptr, sizeof(nextptr), 1, fp_postings);
    return head;
}
