#ifndef BINARY_SEARCH_H
#define BINARY_SEARCH_H

#include <assert.h>
#include <string.h>

/*
 * Searches the given array for the given word 'n' is the dimension of the array.
 * Returns the position of the located element or ERROR.
 */
static inline int binary_search(const char* word, const char* array[], int n) {
    assert(n > 0);
    int low  = 0;
    int high = n - 1;

    while (low <= high) {
        int mid = (low + high) / 2;
        int res = strcmp(word, array[mid]);
        if (res < 0)
            high = mid - 1;
        else if (res > 0)
            low = mid + 1;
        else
            return mid;
    }
    return ERROR;
}

#endif