#ifndef COMMON_WORDS_H
#define COMMON_WORDS_H

#include "binary_search.h"

static const char* common_words[] =
    { "a", "about", "after", "against", "all", "also", "an", "and", "another",
      "any", "are", "as", "at", "back", "be", "because", "been", "before",
      "being", "between", "both", "but", "by", "came", "can", "come", "could",
      "day", "did", "do", "down", "each", "even", "first", "for", "from",
      "get", "go", "good", "great", "had", "has", "have", "he", "her", "here",
      "him", "his", "how", "i", "if", "in", "into", "is", "it", "its", "just",
      "know", "last", "life", "like", "little", "long", "made", "make", "man",
      "many", "may", "me", "men", "might", "more", "most", "mr", "much",
      "must", "my", "never", "new", "no", "not", "now", "of", "off", "old",
      "on", "one", "only", "or", "other", "our", "out", "over", "own",
      "people", "right", "said", "same", "see", "she", "should", "since",
      "so", "some", "state", "still", "such", "take", "than", "that", "the",
      "their", "them", "then", "there", "these", "they", "this", "those",
      "three", "through", "time", "to", "too", "two", "under", "up", "us",
      "used", "very", "was", "way", "we", "well", "were", "what", "when",
      "where", "which", "while", "who", "will", "with", "work", "world",
      "would", "year", "years", "you", "your" };

#define NO_COMMON_WORDS (sizeof(common_words) / sizeof(char*))

/*
 * Return TRUE if 'word' is in the list of common words.
 */
static inline int is_common(const char* word) {
    int pos = binary_search(word, common_words, NO_COMMON_WORDS);
    return pos == ERROR ? FALSE : TRUE;
}

#endif